HDU - 1973 - Prime Path (BFS)

Prime Path

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 987    Accepted Submission(s): 635


Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
—I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
—In fact, I do. You see, there is this programming contest going on. . .

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
 
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
 
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
 
Sample Input
3
1033 8179
1373 8017
1033 1033
 
Sample Output
6
7
0
 
Source
 
Recommend
wangye
 
 
题意:给你两个四位数,都是素数,每次改变可以改变其中的任何一个数字,但要求改变后的四位数(没有前导零)依然是素数,问最少改变几次可以使得第一个数改为第二个数
思路:可以先用埃氏筛法把1000-9999的所有的素数都选出来,之后就四个位数,每个位数最多改变八次,就搜索一下,我开了isprime和step两个数组,当然也可以开一个结构体,但只改变一个数字需要花点功夫,我是枚举了个位,十位,百位,千位。
 
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<cmath>
#include<cstdlib>
#include<queue>
#include<set>
#include<vector>
using namespace std;
#define INF 0x3f3f3f3f
#define eps 1e-10
#define PI acos(-1.0)
#define ll long long
int const maxn = 9999;
const int mod = 1e9 + 7;
int gcd(int a, int b) {
    if (b == 0) return a;  return gcd(b, a % b);
}

bool isprime[maxn];
int step[maxn];
bool vis[maxn];
int num1,num2;
void getprime(int n)
{
    for(int i=0;i<=n;i++)
        isprime[i]=true;
    isprime[0]=isprime[1]=false;
    for(int i=2;i<=n;i++)
    {
        for(int j=2*i;j<=n;j=j+i)
            isprime[j]=false;
    }
}

int bfs(int st )
{
 
    vis[st]=true;
    step[st]=0;
    queue<int>que;
    que.push(st);
    while(que.size())
    {
        int p=que.front();
        que.pop();
        if(p == num2)
        {
            return step[num2];
            break;
        }
        int ge=p % 10;
        int shi=(p/10)%10;
        int bai=(p/100)%10;
        int qian=p/1000;
        for(int i=0;i<=9;i++)
        {
            int next;
            if(i!=ge)
            {
                next=p-ge+i;
                if(next>=1000 && next<=9999 && isprime[next] && vis[next]==false)
                {
                    step[next]=step[p]+1;
                    que.push(next);
                    vis[next]=true;
                    //   cout<<"ge";
                }
            }
            if(i!=shi)
            {
                next=p-shi*10+i*10;
                if(next>=1000 && next<=9999 && isprime[next] && vis[next]==false)
                {
                    step[next]=step[p]+1;
                    que.push(next);
                    vis[next]=true;
                //    cout<<"shi";
                }
            }
            if(i!=bai)
            {
                next=p-bai*100+i*100;
                if(next>=1000 && next<=9999 && isprime[next] && vis[next]==false)
                {
                    step[next]=step[p]+1;
                    que.push(next);
                    vis[next]=true;
                //    cout<<"bai";
                }
            }
            if(i!=qian)
            {
                next=p-qian*1000+i*1000;
                if(next>=1000 && next<=9999 && isprime[next] && vis[next]==false)
                {
                    step[next]=step[p]+1;
                    que.push(next);
                    vis[next]=true;
               //     cout<<"qian";
                }
            }
        }
            
    }
    return -1;
}
int main()
{
    int t;
    scanf("%d",&t);
    getprime(9999);
    while(t--)
    {
        memset(vis,false,sizeof(vis));
        memset(step,0,sizeof(step));
        scanf("%d %d",&num1,&num2);
        
//        for(int i=2;i<=9999;i++)
//            if(isprime[i])
//                cout<<i<<" ";
        int ans=bfs(num1);
        if(ans>=0)
          printf("%d\n",ans);
        else
            printf("Impossible\n");
    }
}

猜你喜欢

转载自www.cnblogs.com/smallhester/p/9567606.html